<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>BBB</title>
    <style>
        html, body, div, iframe {
            width: 100%;
            height: 100%;
            margin: 0;
            overflow: hidden;
            border: 0;
        }
        #form {
            text-align: center;
            font-size: xx-large;
        }
        button {
            width: 200pt;
            height: 30pt;
            margin: 10pt;
        }
    </style>
</head>

<body>
    <div id="container">
        <div id="form">
            <label for="fname">Dein Name:</label><br>
            <input type="text" id="fname" name="fname"><br>
            <button onclick="login(location.hash.split('#').join(''), document.getElementById('fname').value)">Meeting betreten!</button>
        </div>
    </div>
    <script>
function get(url) {
	// Return a new promise.
	return new Promise(function(resolve, reject) {
		// Do the usual XHR stuff
		var req = new XMLHttpRequest();
		req.open('GET', url);

		req.onload = function() {
			// This is called even on 404 etc
			// so check the status
			if (req.status === 200) {
				// Resolve the promise with the response text
				resolve(req.response);
			}
			else {
				// Otherwise reject with the status text
				// which will hopefully be a meaningful error
				reject(Error(req.statusText));
			}
		};

		// Handle network errors
		req.onerror = function() {
			reject(Error("Network Error"));
		};

		// Make the request
		req.send();
	});
}
function fixedEncodeURIComponent(str) {
	return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
		return '%' + c.charCodeAt(0).toString(16);
	});
}
async function login(room, displayName) {
    try{
        const result = JSON.parse(await get(`https://c101-216.cloud.gwdg.de/bbb-resolver-cgi/resolver?room=${room}&name=${fixedEncodeURIComponent(displayName)}`));
        if(result.error) {
            document.getElementById("container").innerHTML = `Fehler beim Auflösen der BBB-Raum Informationen:\n  ${result.error}\nMit diesem Link kannst du den BBB-Raum in einem neuen Tab öffnen:\n <a href="https://meet.gwdg.de/b/${room}">https://meet.gwdg.de/b/${room}</a>`;
            return;
        }
        const url = result.bbbjoinurl;
        console.log(`url: `, url);
        const iframe = `<iframe src="${url}" allow="camera; autoplay; microphone; fullscreen; display-capture" allowfullscreen="true"></iframe>`;
        document.getElementById("container").innerHTML = iframe;
    } catch (e) {
        console.error(e);
        document.getElementById("container").innerHTML = e;
    }
}

    </script>
</body>

</html>
